Index: cpukit/libmisc/monitor/mon-monitor.c
===================================================================
--- cpukit/libmisc/monitor/mon-monitor.c	(revision 637df35f96d8023056369fcf2c9943419f1a1b74)
+++ cpukit/libmisc/monitor/mon-monitor.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -1,25 +1,26 @@
 /*
- *	@(#)monitor.c	1.6 - 95/04/24
+ *	@(#)monitor.c	1.18 - 95/08/02
  *	
- */
-
-/*
- *  mon-task.c
- *
- *  Description:
- *	RTEMS monitor task
- *	
- *	
+ *
+ * RTEMS monitor main body
  *	
  *  TODO:
- *	add pause command (monitor sleeps for 'n' ticks, then wakes up)
- *      
+ *      add stuff to RTEMS api
+ *            rtems_get_name(id)
+ *            rtems_get_type(id)
+ *            rtems_build_id(node, type, num)
+ *      Add a command to dump out info about an arbitrary id when
+ *         types are added to id's
+ *         rtems> id idnum
+ *                idnum: node n, object: whatever, id: whatever
+ *      allow id's to be specified as n:t:id, where 'n:t' is optional
+ *      should have a separate monitor FILE stream (ala the debugger)
+ *      remote request/response stuff should be cleaned up
+ *         maybe we can use real rpc??
+ *
+ *  $Id$
  */
 
 #include <rtems.h>
-/* #include <bsp.h> */
-
-#include "symbols.h"
-#include "monitor.h"
 
 #include <stdio.h>
@@ -28,5 +29,5 @@
 #include <unistd.h>
 
-#define STREQ(a,b)	(strcmp(a,b) == 0)
+#include "monitor.h"
 
 /* set by trap handler */
@@ -35,90 +36,203 @@
 extern rtems_unsigned32 debugger_trap;
 
-/* our task id needs to be public so any debugger can resume us */
-rtems_unsigned32        rtems_monitor_task_id;
-
+/*
+ * Various id's for the monitor
+ * They need to be public variables for access by other agencies
+ * such as debugger and remote servers'
+ */
+
+rtems_id  rtems_monitor_task_id;
+
+unsigned32 rtems_monitor_node;		/* our node number */
+unsigned32 rtems_monitor_default_node;  /* current default for commands */
+
+/*
+ * The rtems symbol table
+ */
 
 rtems_symbol_table_t *rtems_monitor_symbols;
 
-
-#ifndef MONITOR_PROMPT
-#define MONITOR_PROMPT "rtems> "
+/*
+ * The top-level commands
+ */
+
+rtems_monitor_command_entry_t rtems_monitor_commands[] = {
+    { "--usage--",
+      "\n"
+      "RTEMS monitor\n"
+      "\n"
+      "Commands (may be abbreviated)\n"
+      "\n"
+      "  help      -- get this message or command specific help\n"
+      "  pause     -- pause monitor for a specified number of ticks\n"
+      "  exit      -- invoke a fatal RTEMS error\n"
+      "  symbol    -- show entries from symbol table\n"
+      "  continue  -- put monitor to sleep waiting for explicit wakeup\n"
+      "  config    -- show system configuration\n"
+      "  itask     -- list init tasks\n"
+      "  mpci      -- list mpci config\n"
+      "  task      -- show task information\n"
+      "  queue     -- show message queue information\n"
+      "  extension -- user extensions\n"
+      "  driver    -- show information about named drivers\n"
+      "  object    -- generic object information\n"
+      "  node      -- specify default node for commands that take id's\n"
+#ifdef CPU_INVOKE_DEBUGGER
+      "  debugger  -- invoke system debugger\n"
 #endif
-
-#define MONITOR_WAKEUP_EVENT   RTEMS_EVENT_0
-
-/*
- *  Function:	rtems_monitor_init
- *
- *  Description:
- *	Create the RTEMS monitor task
- *	
- *  Parameters:
- *	'monitor_suspend' arg is passed as initial arg to monitor task
- *      If TRUE, monitor will suspend itself as it starts up.  Otherwise
- *      it will begin its command loop.
- *	
- *  Returns:
- *	
- *	
- *  Side Effects:
- *	
- *	
- *  Notes:
- *	
- *	
- *  Deficiencies/ToDo:
- *	
- *	
- */
-
-/*
- * make_argv(cp): token-count
- *	Break up the command line in 'cp' into global argv[] and argc (return
- *	value).
- */
-
-int
-rtems_monitor_make_argv(
-    char *cp,
-    int  *argc_p,
-    char **argv)
-{
-    int argc = 0;
-
-    while ((cp = strtok(cp, " \t\n\r")))
-    {
-	argv[argc++] = cp;
-	cp = (char *) NULL;
-    }
-    argv[argc] = (char *) NULL;			/* end of argv */
-
-    return *argc_p = argc;
-}
-
-void
-rtems_monitor_init(rtems_boolean monitor_suspend)
-{
-    rtems_status_code status;
-    
-    status = rtems_task_create(rtems_build_name('R', 'M', 'O', 'N'),
-                               1, 0/*stack*/, RTEMS_NO_PREEMPT | RTEMS_INTERRUPT_LEVEL(0), RTEMS_DEFAULT_ATTRIBUTES, &rtems_monitor_task_id);
-    if (status != RTEMS_SUCCESSFUL)
-    {
-        printf("could not create monitor task\n");
-        goto done;
-    }
-
-    rtems_monitor_symbols_loadup();
-
-    status = rtems_task_start(rtems_monitor_task_id, rtems_monitor_task, monitor_suspend);
-    if (status != RTEMS_SUCCESSFUL)
-    {
-        printf("could not start monitor!\n");
-        goto done;
-    }
-
-done:
-}
+      ,
+      0,
+      0,
+      (unsigned32) rtems_monitor_commands,
+    },
+    { "config",
+      "config\n"
+      "  Show the system configuration.\n",
+      0,
+      rtems_monitor_object_cmd,
+      RTEMS_OBJECT_CONFIG,
+    },
+    { "itask",
+      "itask\n"
+      "  List init tasks for the system\n",
+      0,
+      rtems_monitor_object_cmd,
+      RTEMS_OBJECT_INIT_TASK,
+    }, 
+   { "mpci",
+      "mpci\n"
+      "  Show the MPCI system configuration, if configured.\n",
+      0,
+      rtems_monitor_object_cmd,
+      RTEMS_OBJECT_MPCI,
+    },
+    { "pause",
+      "pause [ticks]\n"
+      "  monitor goes to \"sleep\" for specified ticks (default is 1)\n"
+      "  monitor will resume at end of period or if explicitly awakened\n",
+      0,
+      rtems_monitor_pause_cmd,
+      0,
+    },
+    { "continue",
+      "continue\n"
+      "  put the monitor to sleep waiting for an explicit wakeup from the\n"
+      "  program running.\n",
+      0,
+      rtems_monitor_continue_cmd,
+      0,
+    },
+    { "go",
+      "go\n"
+      "  Alias for 'continue'\n",
+      0,
+      rtems_monitor_continue_cmd,
+      0,
+    },
+    { "node",
+      "node [ node number ]\n"
+      "  Specify default node number for commands that take id's\n",
+      0,
+      rtems_monitor_node_cmd,
+      0,
+    },
+    { "symbol",
+      "symbol [ symbolname [symbolname ... ] ]\n"
+      "  display value associated with specified symbol.\n"
+      "  Defaults to displaying all known symbols.\n",
+      0,
+      rtems_monitor_symbol_cmd,
+      (unsigned32) &rtems_monitor_symbols,
+    },
+    { "extension",
+      "extension [id [id ...] ]\n"
+      "  display information about specified extensions.\n"
+      "  Default is to display information about all extensions on this node\n",
+      0,
+      rtems_monitor_object_cmd,
+      RTEMS_OBJECT_EXTENSION,
+    },
+    { "task",
+      "task [id [id ...] ]\n"
+      "  display information about the specified tasks.\n"
+      "  Default is to display information about all tasks on this node\n",
+      0,
+      rtems_monitor_object_cmd,
+      RTEMS_OBJECT_TASK,
+    },
+    { "queue",
+      "queue [id [id ... ] ]\n"
+      "  display information about the specified message queues\n"
+      "  Default is to display information about all queues on this node\n",
+      0,
+      rtems_monitor_object_cmd,
+      RTEMS_OBJECT_QUEUE,
+    },
+    { "object",
+      "object [id [id ...] ]\n"
+      "  display information about specified RTEMS objects.\n"
+      "  Object id's must include 'type' information.\n"
+      "  (which may normally be defaulted)\n",
+      0,
+      rtems_monitor_object_cmd,
+      RTEMS_OBJECT_INVALID,
+    },
+    { "driver",
+      "driver [ major [ major ... ] ]\n"
+      "  Display the RTEMS device driver table.\n",
+      0,
+      rtems_monitor_object_cmd,
+      RTEMS_OBJECT_DRIVER,
+    },
+    { "dname",
+      "dname\n"
+      "  Displays information about named drivers.\n",
+      0,
+      rtems_monitor_object_cmd,
+      RTEMS_OBJECT_DNAME,
+    },
+    { "exit",
+      "exit [status]\n"
+      "  Invoke 'rtems_fatal_error_occurred' with 'status'\n"
+      "  (default is RTEMS_SUCCESSFUL)\n",
+      0,
+      rtems_monitor_fatal_cmd,
+      RTEMS_SUCCESSFUL,
+    },
+    { "fatal",
+      "fatal [status]\n"
+      "  'exit' with fatal error; default error is RTEMS_TASK_EXITTED\n",
+      0,
+      rtems_monitor_fatal_cmd,
+      RTEMS_TASK_EXITTED,			/* exit value */
+    },
+    { "quit",
+      "quit [status]\n"
+      "  Alias for 'exit'\n",
+      0,
+      rtems_monitor_fatal_cmd,
+      RTEMS_SUCCESSFUL,				/* exit value */
+    },
+    { "help",
+      "help [ command [ command ] ]\n"
+      "  provide information about commands\n"
+      "  Default is show basic command summary.\n",
+      0,
+      rtems_monitor_help_cmd,
+      (unsigned32) rtems_monitor_commands,
+    },
+#ifdef CPU_INVOKE_DEBUGGER
+    { "debugger",
+      "debugger\n"
+      "  Enter the debugger, if possible.\n"
+      "  A continue from the debugger will return to the monitor.\n",
+      0,
+      CPU_INVOKE_DEBUGGER,
+      0,
+    },
+#endif            
+    { 0, 0, 0, 0, 0 },
+};
+
 
 rtems_status_code
@@ -128,5 +242,8 @@
     rtems_status_code status;
     
-    status = rtems_event_receive(MONITOR_WAKEUP_EVENT, RTEMS_DEFAULT_OPTIONS, timeout, &event_set);
+    status = rtems_event_receive(MONITOR_WAKEUP_EVENT,
+                                 RTEMS_DEFAULT_OPTIONS,
+                                 timeout,
+                                 &event_set);
     return status;
 }
@@ -141,90 +258,73 @@
 
 
-/*
- * Read and break up a monitor command
- *
- * We have to loop on the gets call, since it will return NULL under UNIX
- *  RTEMS when we get a signal (eg: SIGALRM).
- */
-
-int
-rtems_monitor_read_command(char *command,
-                           int  *argc,
-                           char **argv)
-{
-    printf("%s", MONITOR_PROMPT);  fflush(stdout);
-    while (gets(command) == (char *) 0)
-        ;
-    return rtems_monitor_make_argv(command, argc, argv);
-}
-
-void
-rtems_monitor_task(rtems_task_argument monitor_suspend)
-{
-    rtems_tcb *debugee = 0;
-    char command[513];
-    rtems_context *rp;
-    rtems_context_fp *fp;
-    char *cp;
-    int argc;
-    char *argv[64];        
-
-    if ((rtems_boolean) monitor_suspend)
-        (void) rtems_monitor_suspend(RTEMS_NO_TIMEOUT);
-
-    for (;;)
+void
+rtems_monitor_pause_cmd(
+    int        argc,
+    char     **argv,
+    unsigned32 command_arg,
+    boolean    verbose
+)
+{
+    if (argc == 1)
+        rtems_monitor_suspend(1);
+    else
+        rtems_monitor_suspend(strtoul(argv[1], 0, 0));
+}
+
+void
+rtems_monitor_fatal_cmd(
+    int     argc,
+    char  **argv,
+    unsigned32 command_arg,
+    boolean verbose
+)
+{
+    if (argc == 1)
+        rtems_fatal_error_occurred(command_arg);
+    else
+        rtems_fatal_error_occurred(strtoul(argv[1], 0, 0));
+}
+
+void
+rtems_monitor_continue_cmd(
+    int     argc,
+    char  **argv,
+    unsigned32 command_arg,
+    boolean verbose
+)
+{
+    rtems_monitor_suspend(RTEMS_NO_TIMEOUT);
+}
+
+
+void
+rtems_monitor_node_cmd(
+    int     argc,
+    char  **argv,
+    unsigned32 command_arg,
+    boolean verbose
+)
+{
+    unsigned32 new_node = rtems_monitor_default_node;
+    
+    switch (argc)
     {
-        extern rtems_tcb * _Thread_Executing;
-        debugee = _Thread_Executing;
-        rp = &debugee->Registers;
-        fp = (rtems_context_fp *) debugee->fp_context;  /* possibly 0 */
-
-        if (0 == rtems_monitor_read_command(command, &argc, argv))
-            continue;
-        
-        if (STREQ(argv[0], "quit"))
-            rtems_monitor_suspend(RTEMS_NO_TIMEOUT);
-        else if (STREQ(argv[0], "pause"))
-            rtems_monitor_suspend(1);
-
-#ifdef CPU_INVOKE_DEBUGGER
-        else if (STREQ(argv[0], "debug"))
-        {
-            CPU_INVOKE_DEBUGGER;
-        }
-#endif            
-        else if (STREQ(argv[0], "symbol"))
-        {
-            char *symbol;
-            char *value;
-
-            if (argc != 3)
-            {
-                printf("usage: symbol symname symvalue\n");
-                continue;
-            }
-
-            symbol = argv[1];
-            value = argv[2];
-            if (symbol && value)
-            {
-                rtems_symbol_t *sp;
-                sp = rtems_symbol_create(rtems_monitor_symbols,
-                                         symbol,
-                                         (rtems_unsigned32) strtoul(value, 0, 16));
-                if (sp)
-                    printf("symbol defined is at %p\n", sp);
-                else
-                    printf("could not define symbol\n");
-            }
-            else
-                printf("parsing error\n");
-        }
-        else
-        {
-            printf("Unrecognized command: '%s'\n", argv[0]);
-        }
+        case 1: 		/* no node, just set back to ours */
+            new_node = rtems_monitor_node;
+            break;
+
+        case 2:
+            new_node = strtoul(argv[1], 0, 0);
+            break;
+
+        default:
+            printf("invalid syntax, try 'help node'\n");
+            break;
     }
-}
+
+    if ((new_node >= 1) && (new_node <= _Configuration_MP_table->maximum_nodes))
+        rtems_monitor_default_node = new_node;
+}
+
 
 /*
@@ -267,9 +367,17 @@
     char buffer[128];
 
+    if (rtems_monitor_symbols)
+        rtems_symbol_table_destroy(rtems_monitor_symbols);
+    
     rtems_monitor_symbols = rtems_symbol_table_create(10);
     if (rtems_monitor_symbols == 0)
         return;
 
-    fp = fdopen(8, "r");
+#ifdef simhppa
+    fp = fdopen(8, "r");                /* don't ask; don't tell */
+#else
+    fp = fopen("symbols", "r");
+#endif
+    
     if (fp == 0)
         return;
@@ -293,5 +401,5 @@
             if (sp == 0)
             {
-                printf("could not define symbol\n");
+                printf("could not define symbol '%s'\n", symbol);
                 goto done;
             }
@@ -299,5 +407,5 @@
         else
         {
-            printf("parsing error\n");
+            printf("parsing error on '%s'\n", buffer);
             goto done;
         }
@@ -306,2 +414,101 @@
 done:
 }
+
+
+/*
+ * Main monitor command loop
+ */
+
+void
+rtems_monitor_task(
+    rtems_task_argument monitor_flags
+)
+{
+    rtems_tcb *debugee = 0;
+    rtems_context *rp;
+    rtems_context_fp *fp;
+    char command_buffer[513];
+    int argc;
+    char *argv[64];        
+    boolean verbose = FALSE;
+
+    if (monitor_flags & RTEMS_MONITOR_SUSPEND)
+        (void) rtems_monitor_suspend(RTEMS_NO_TIMEOUT);
+
+    for (;;)
+    {
+        extern rtems_tcb * _Thread_Executing;
+        rtems_monitor_command_entry_t *command;
+
+        debugee = _Thread_Executing;
+        rp = &debugee->Registers;
+        fp = (rtems_context_fp *) debugee->fp_context;  /* possibly 0 */
+
+        if (0 == rtems_monitor_command_read(command_buffer, &argc, argv))
+            continue;
+        if ((command = rtems_monitor_command_lookup(rtems_monitor_commands,
+                                                    argc,
+                                                    argv)) == 0)
+            continue;
+
+        command->command_function(argc, argv, command->command_arg, verbose);
+
+        fflush(stdout);
+    }
+}
+
+
+void
+rtems_monitor_kill(void)
+{
+    if (rtems_monitor_task_id)
+        rtems_task_delete(rtems_monitor_task_id);
+    rtems_monitor_task_id = 0;
+    
+    rtems_monitor_server_kill();
+}
+
+void
+rtems_monitor_init(
+    unsigned32 monitor_flags
+)
+{
+    rtems_status_code status;
+    
+    rtems_monitor_kill();
+
+    status = rtems_task_create(RTEMS_MONITOR_NAME,
+                               1,
+                               0 /* default stack */,
+                               RTEMS_INTERRUPT_LEVEL(0),
+                               RTEMS_DEFAULT_ATTRIBUTES,
+                               &rtems_monitor_task_id);
+    if (status != RTEMS_SUCCESSFUL)
+    {
+        rtems_error(status, "could not create monitor task");
+        goto done;
+    }
+
+    rtems_monitor_node = rtems_get_node(rtems_monitor_task_id);
+    rtems_monitor_default_node = rtems_monitor_node;
+
+    rtems_monitor_symbols_loadup();
+
+    if (monitor_flags & RTEMS_MONITOR_GLOBAL)
+        rtems_monitor_server_init(monitor_flags);
+
+    /*
+     * Start the monitor task itself
+     */
+    
+    status = rtems_task_start(rtems_monitor_task_id,
+                              rtems_monitor_task,
+                              monitor_flags);
+    if (status != RTEMS_SUCCESSFUL)
+    {
+        rtems_error(status, "could not start monitor");
+        goto done;
+    }
+
+done:
+}
Index: cpukit/libmisc/monitor/mon-mpci.c
===================================================================
--- cpukit/libmisc/monitor/mon-mpci.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-mpci.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,161 @@
+/*
+ *	@(#)mpci.c	1.6 - 95/08/02
+ *	
+ *
+ * RTEMS MPCI Config display support
+ *
+ * TODO
+ *
+ *  $Id$
+ */
+
+
+#include <rtems.h>
+#include "monitor.h"
+
+#include <stdio.h>
+#include <stdlib.h>             /* strtoul() */
+
+#define DATACOL 15
+
+/*
+ * Fill in entire monitor config table
+ * for sending to a remote monitor or printing on the local system
+ */
+
+void
+rtems_monitor_mpci_canonical(
+    rtems_monitor_mpci_t *canonical_mpci,
+    void                  *config_void
+)
+{
+    rtems_configuration_table *c = _Configuration_Table;
+    rtems_multiprocessing_table *m;
+    rtems_mpci_table *mt;
+
+    m = c->User_multiprocessing_table;
+    if (m == 0)
+        return;
+    mt = m->User_mpci_table;
+    
+    canonical_mpci->node = m->node;
+    canonical_mpci->maximum_nodes = m->maximum_nodes;
+    canonical_mpci->maximum_global_objects = m->maximum_global_objects;
+    canonical_mpci->maximum_proxies = m->maximum_proxies;
+
+    canonical_mpci->default_timeout = mt->default_timeout;
+    canonical_mpci->maximum_packet_size = mt->maximum_packet_size;
+
+    rtems_monitor_symbol_canonical_by_value(&canonical_mpci->initialization,
+                                            mt->initialization);
+
+    rtems_monitor_symbol_canonical_by_value(&canonical_mpci->get_packet,
+                                            mt->get_packet);
+    rtems_monitor_symbol_canonical_by_value(&canonical_mpci->return_packet,
+                                            mt->return_packet);
+    rtems_monitor_symbol_canonical_by_value(&canonical_mpci->send_packet,
+                                            mt->send_packet);
+    rtems_monitor_symbol_canonical_by_value(&canonical_mpci->receive_packet,
+                                            mt->receive_packet);
+}    
+
+/*
+ * This is easy, since there is only 1 (altho we could get them from
+ *    other nodes...)
+ */
+
+void *
+rtems_monitor_mpci_next(
+    void                  *object_info,
+    rtems_monitor_mpci_t  *canonical_mpci,
+    rtems_id              *next_id
+)
+{
+    rtems_configuration_table *c = _Configuration_Table;
+    int n = rtems_get_index(*next_id);
+
+    if (n >= 1)
+        goto failed;
+    
+    if ( ! c->User_multiprocessing_table)
+        goto failed;
+    
+    _Thread_Disable_dispatch();
+
+    *next_id += 1;
+    return (void *) c;
+
+failed:
+    *next_id = RTEMS_OBJECT_ID_FINAL;
+    return 0;
+}
+
+
+void
+rtems_monitor_mpci_dump_header(
+    boolean verbose
+)
+{
+    printf("\
+           max     max     max     default    max\n\
+   node   nodes  globals  proxies  timeout  pktsize\n");
+/*23456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
+0         1         2         3         4         5         6         7       */
+           
+    rtems_monitor_separator();
+}
+
+
+void
+rtems_monitor_mpci_dump(
+    rtems_monitor_mpci_t *monitor_mpci,
+    boolean               verbose
+)
+{
+    unsigned32   length = 0;
+
+    length += rtems_monitor_pad(2, length);
+    length += printf("  %d", monitor_mpci->node);
+    length += rtems_monitor_pad(11, length);
+    length += printf("%d", monitor_mpci->maximum_nodes);
+    
+    length += rtems_monitor_pad(18, length);
+    length += rtems_monitor_dump_decimal(monitor_mpci->maximum_global_objects);
+    
+    length += rtems_monitor_pad(28, length);
+    length += rtems_monitor_dump_decimal(monitor_mpci->maximum_proxies);
+
+    length += rtems_monitor_pad(37, length);
+    length += rtems_monitor_dump_decimal(monitor_mpci->default_timeout);
+
+    length += rtems_monitor_pad(46, length);
+    length += rtems_monitor_dump_decimal(monitor_mpci->maximum_packet_size);
+
+    printf("\n");
+    length = 0;
+    length += rtems_monitor_pad(DATACOL, length);
+
+    length += printf("init: ");
+    length += rtems_monitor_symbol_dump(&monitor_mpci->initialization, verbose);
+
+    printf("\n");
+    length = 0;
+    length += rtems_monitor_pad(DATACOL, length);
+
+    length += printf("get: ");
+    length += rtems_monitor_symbol_dump(&monitor_mpci->get_packet, verbose);
+    length += printf(";  return: ");
+    length += rtems_monitor_symbol_dump(&monitor_mpci->return_packet, verbose);
+
+    printf("\n");
+    length = 0;
+    length += rtems_monitor_pad(DATACOL, length);
+
+    length += printf("send: ");
+    length += rtems_monitor_symbol_dump(&monitor_mpci->send_packet, verbose);
+    length += printf(";  receive: ");
+    length += rtems_monitor_symbol_dump(&monitor_mpci->receive_packet, verbose);
+
+    printf("\n");
+    length = 0;
+}
